/*
 * Copyright 2010-2015 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jetbrains.kotlin.completion.handlers;

import com.intellij.testFramework.TestDataPath;
import org.jetbrains.kotlin.test.InnerTestClasses;
import org.jetbrains.kotlin.test.JUnit3RunnerWithInners;
import org.jetbrains.kotlin.test.JetTestUtils;
import org.jetbrains.kotlin.test.TestMetadata;
import org.junit.runner.RunWith;

import java.io.File;
import java.util.regex.Pattern;

/** This class is generated by {@link org.jetbrains.kotlin.generators.tests.TestsPackage}. DO NOT MODIFY MANUALLY */
@SuppressWarnings("all")
@TestMetadata("idea/testData/completion/handlers/keywords")
@TestDataPath("$PROJECT_ROOT")
@RunWith(JUnit3RunnerWithInners.class)
public class KeywordCompletionHandlerTestGenerated extends AbstractKeywordCompletionHandlerTest {
    public void testAllFilesPresentInKeywords() throws Exception {
        JetTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/completion/handlers/keywords"), Pattern.compile("^(.+)\\.kt$"), true);
    }

    @TestMetadata("Break.kt")
    public void testBreak() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/Break.kt");
        doTest(fileName);
    }

    @TestMetadata("FileKeyword.kt")
    public void testFileKeyword() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/FileKeyword.kt");
        doTest(fileName);
    }

    @TestMetadata("NoSpaceAfterNull.kt")
    public void testNoSpaceAfterNull() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/NoSpaceAfterNull.kt");
        doTest(fileName);
    }

    @TestMetadata("QualifiedReturnNonUnit.kt")
    public void testQualifiedReturnNonUnit() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/QualifiedReturnNonUnit.kt");
        doTest(fileName);
    }

    @TestMetadata("QualifiedReturnNonUnitExplicit.kt")
    public void testQualifiedReturnNonUnitExplicit() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/QualifiedReturnNonUnitExplicit.kt");
        doTest(fileName);
    }

    @TestMetadata("QualifiedReturnUnit.kt")
    public void testQualifiedReturnUnit() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/QualifiedReturnUnit.kt");
        doTest(fileName);
    }

    @TestMetadata("ReturnInEmptyType.kt")
    public void testReturnInEmptyType() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/ReturnInEmptyType.kt");
        doTest(fileName);
    }

    @TestMetadata("ReturnInProperty.kt")
    public void testReturnInProperty() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/ReturnInProperty.kt");
        doTest(fileName);
    }

    @TestMetadata("ReturnInTypeFunction.kt")
    public void testReturnInTypeFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/ReturnInTypeFunction.kt");
        doTest(fileName);
    }

    @TestMetadata("ReturnInUnit.kt")
    public void testReturnInUnit() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/ReturnInUnit.kt");
        doTest(fileName);
    }

    @TestMetadata("SpaceAfterImport.kt")
    public void testSpaceAfterImport() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/handlers/keywords/SpaceAfterImport.kt");
        doTest(fileName);
    }
}
